︠73984cee-3b70-4a2c-b34d-3af49a8fb4d1i︠
%html
<h1>ESBS</h1>
<h1>Biophysics practicals 2012</h1>
<p>This SAGE notebook contains some hints and programs that will allow you to analyse the data recorded during the experiments. Exemples are provided to show you the more appropriate way to analyse and display your data. The graphics could be exported directly to fit within your reports as png files.</p>
<h2>1. TP 2 Mass transport : Non-linear fitting of the time dependant evolution of the gel's temperature</h2>
<p>The time evolution of the gel's temperature could be modelled using the following equation:</p>
<p>$$T(t)=A+B\left(1-e^{-Ct}\right)$$</p>
<p>where $$A=T_{0},&nbsp;&nbsp;&nbsp; B=\frac{P}{aC}&nbsp;&nbsp; and &nbsp; C=a$$</p>
<ul>
<li><strong>First :</strong> Get an idea of the effect of each of the parameters on the curve using the following interactive plot</li>
</ul>
<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; In particular, check which parameter influences 1) the value of the plateau 2) the initial slope</p>
<p>&nbsp;</p>

︡864a0086-3063-4521-93d2-2dbd06a862cd︡{"html": "<h1>ESBS</h1>\n<h1>Biophysics practicals 2012</h1>\n<p>This SAGE notebook contains some hints and programs that will allow you to analyse the data recorded during the experiments. Exemples are provided to show you the more appropriate way to analyse and display your data. The graphics could be exported directly to fit within your reports as png files.</p>\n<h2>1. TP 2 Mass transport : Non-linear fitting of the time dependant evolution of the gel's temperature</h2>\n<p>The time evolution of the gel's temperature could be modelled using the following equation:</p>\n<p>$$T(t)=A+B\\left(1-e^{-Ct}\\right)$$</p>\n<p>where $$A=T_{0},&nbsp;&nbsp;&nbsp; B=\\frac{P}{aC}&nbsp;&nbsp; and &nbsp; C=a$$</p>\n<ul>\n<li><strong>First :</strong> Get an idea of the effect of each of the parameters on the curve using the following interactive plot</li>\n</ul>\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; In particular, check which parameter influences 1) the value of the plateau 2) the initial slope</p>\n<p>&nbsp;</p>"}︡
︠2bef39b8-1e2a-4fb7-a541-2ca1b7feb899︠
@interact
def _(A=(10..100),B=(1..10),CI=(1..20)):
    C=CI*0.001
    f(t) = A + B*(1-exp(-C*t))
    pf = plot(f,0,1000,axes_labels=['Time (s)','Temp (Deg C)'])
    show(pf)
︡eec01bcc-0b75-4736-a5ab-4ed990da10f4︡︡
︠f57c90a0-20df-4fff-94c8-d7425e0bbe26i︠
%html
<ul>
<li><strong>Second :</strong> We should define the function to be fitted, in a way that will be recognized by NUMPY</li>
</ul>

︡fb38f807-0336-4a50-ae50-6cd92c6dee65︡{"html": "<ul>\n<li><strong>Second :</strong> We should define the function to be fitted, in a way that will be recognized by NUMPY</li>\n</ul>"}︡
︠193b6817-ffb2-4f3e-a6e8-1269d5637672︠
from numpy import *
def temp(time,pA,pB,pC):
    """ Equation describing heat exchange within an electrophoresis gel"""
    y= pA+pB*(1 - exp(-time*pC))
    return y
︡7d7f0665-36a8-4839-b80c-14eff35e382c︡︡
︠d47cf953-dd84-4f41-b202-01f0d26e59cei︠
%html
<ul>
<li><span id="cell_outer_5"><strong>Third :</strong> The measured values have to be entered in the program. First option : enter the values manually as shown below</span></li>
</ul>

︡965d7ab3-717a-42b6-a429-034660c071da︡{"html": "<ul>\n<li><span id=\"cell_outer_5\"><strong>Third :</strong> The measured values have to be entered in the program. First option : enter the values manually as shown below</span></li>\n</ul>"}︡
︠2528c67f-7817-45a5-86a4-e5d2056d5d9b︠
Times = [10, 30, 100, 300, 400, 600, 800, 1200, 2000]
Texp =  [20.2, 20.5, 21.3, 22.9, 23.3, 23.7, 23.9, 24.0, 24.0]
︡96982765-de76-48c4-ad6e-b8af58cefce0︡︡
︠6c31dc69-66fe-4497-a802-f77fb7c72ebei︠
%html
<p>Second option: download a text file named <span style="background-color: #ff9900;">arduino.dat</span>, that contains the recorded temperatures according the following format:</p>
<p>Fri Mar 16 17:31:34 2012 23.56<br />Fri Mar 16 17:31:40 2012 23.5</p>
<p>And run the following script</p>
<p>...</p>
<p>&nbsp;</p>

︡d4271cd0-54ab-4409-bf54-d9a9c0829d36︡{"html": "<p>Second option: download a text file named <span style=\"background-color: #ff9900;\">arduino.dat</span>, that contains the recorded temperatures according the following format:</p>\n<p>Fri Mar 16 17:31:34 2012 23.56<br />Fri Mar 16 17:31:40 2012 23.5</p>\n<p>And run the following script</p>\n<p>...</p>\n<p>&nbsp;</p>"}︡
︠16c37ee0-7c91-4610-9d26-eb369dfa6c24︠
# arduino prep
# Read Arduino data 
# B. Kieffer Mar 2012

import time 

# 1. Read data into a list all_line
fname = DATA+'arduino.dat'
myfile = open(fname,'r')
all_lines = myfile.readlines()
myfile.close()

txtime = []
Texp = []
Times = []
# 2. Extract relevent informations from all_line
for line in all_lines:
	line_field = line.split()
	time_field = line_field[3]
	val = line_field[5]
	txtime.append(time_field)
	Texp.append(float(val))

# 3. Build a vector of time delays starting from the first point
first = True	
for t in txtime :
   t1 = time.strptime(t, "%H:%M:%S")
   t_sec = t1.tm_hour*3600+t1.tm_min*60+t1.tm_sec
   if first :
      Times.append(0)
      t0 = t_sec # First point is the time 0
      first = False
   else :
      Times.append(t_sec-t0)
print " %i lines read from file arduino.dat " % len(Times)
︡1c032997-fa7d-470e-b63f-ee512b2888c2︡{"stdout": "61 lines read from file arduino.dat"}︡
︠f3d3e1bb-d743-4d41-bbb6-90b964e99076︠
print Times
︡6ffd35aa-5cc1-45d0-8ad5-5c8ada7285fc︡{"stdout": "[0, 31, 60, 91, 120, 150, 180, 210, 240, 270, 301, 330, 361, 390, 421, 450, 481, 510, 541, 570, 601, 630, 661, 690, 721, 750, 780, 810, 840, 870, 900, 931, 960, 991, 1020, 1051, 1080, 1111, 1140, 1171, 1200, 1231, 1260, 1291, 1320, 1351, 1380, 1410, 1440, 1470, 1500, 1530, 1560, 1590, 1621, 1650, 1681, 1710, 1741, 1770, 1801]"}︡
︠bf3dc8b6-7d44-44b9-b9ec-f9c954da4febi︠
%html
<ul>
<li><span id="cell_outer_5"><span id="cell_outer_5"><strong>Finally :</strong> Perform the non-linear fit using the program curve_fit that is included in the optimize library of SCIPY<br /></span></span></li>
</ul>

︡4d517645-93c9-4378-bf86-2e83c992ede8︡{"html": "<ul>\n<li><span id=\"cell_outer_5\"><span id=\"cell_outer_5\"><strong>Finally :</strong> Perform the non-linear fit using the program curve_fit that is included in the optimize library of SCIPY<br /></span></span></li>\n</ul>"}︡
︠80027df3-8a99-47a6-9d69-2f58b2e45955︠
from scipy import optimize
# 1. Initialize parameters
Pini = [18., 2., 0.001] # Initial guess of the parameters
Pow = 10.0 # Power in the gel

# 2. Perform the fit
PP, pcov = optimize.curve_fit(temp, array(Times), array(Texp), Pini)

# 3. Report and plot the results
Cap = Pow/(PP[1]*PP[2])
print "Optimized parameters:"
print "T0: %f (Deg C) " % PP[0]
print "Calorific capacity: %f (J.K-1)  Rate: %f (s-1)"%(Cap,PP[2])
a = scatter_plot(zip(Times,Texp))
a += plot(temp(x,PP[0],PP[1],PP[2]), 0,max(Times),axes_labels=['Time (s)','Temp (Deg C)'])
show(a)
︡46bcc3e4-d979-4444-ac36-c0465ed2096e︡{"stdout": "Optimized parameters:\nT0: 20.059797 (Deg C) \nCalorific capacity: 1141.509034 (J.K-1)  Rate: 0.001589 (s-1)"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
